/*
             LUFA Library
     Copyright (C) Dean Camera, 2017.

  dean [at] fourwalledcubicle [dot] com
           www.lufa-lib.org
*/

/*
  Copyright 2017  Dean Camera (dean [at] fourwalledcubicle [dot] com)

  Permission to use, copy, modify, distribute, and sell this
  software and its documentation for any purpose is hereby granted
  without fee, provided that the above copyright notice appear in
  all copies and that both that the copyright notice and this
  permission notice and warranty disclaimer appear in supporting
  documentation, and that the name of the author not be used in
  advertising or publicity pertaining to distribution of the
  software without specific, written prior permission.

  The author disclaims all warranties with regard to this
  software, including all implied warranties of merchantability
  and fitness.  In no event shall the author be liable for any
  special, indirect or consequential damages or any damages
  whatsoever resulting from loss of use, data or profits, whether
  in an action of contract, negligence or other tortious action,
  arising out of or in connection with the use or performance of
  this software.
*/

/*
Copyright (c) 2017, aweatherguy
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
Neither the name of the <organization> nor the
names of its contributors may be used to endorse or promote products
derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

;
; All items that used to be here to provide an API for applications have been 
; removed to save space. This now only consume 8 bytes so a total of 4088 bytes 
; are available for the rest of the bootloader.
;
; Bootloader table signatures and information
; At FLASHEND-8. There was originally the address of BOOT_START_ADDR in the first
; four bytes of this section, but that wasn't really used anywhere.
; It is zero for now, but can be set to something meaninful if desired.
; The first four bytes could also be removed, leaving 4092 bytes for bootloader.
;
; Modified on Dec 23 2017 by Jelle Roets from Dwengo vzw (www.dwengo.org)
; remove DeviceDescriptor and serialString api signatures to save 4 bytes, since they aren't used anywhere
#include "Config/AppConfig.h"

.section .apitable_signatures, "ax"
.global BootloaderAPI_Signatures

; .extern DeviceDescriptor
; #if defined( CUSTOM_USB_SERIAL )
; .extern SerialString
; #else
; #define SerialString 0x0000
; #endif

BootloaderAPI_Signatures:

;	.word DeviceDescriptor  ; API so sketch can determin VID/PID
;	.word SerialString      ; API for sketch to find serial number 
	.word 0xDF00	        ; Signature for the CDC class bootloader
	.word 0xDCFB	        ; Signature for a LUFA class bootloader
